package com.penghaisoft.momeam.eammobile.maintainorder.service.impl;

package ..deTemp.1730189530646;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpResponse;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.collect.Lists;
import com.penghaisoft.momeam.commonbase.config.token.UserInfoService;
import com.penghaisoft.momeam.commonbase.entity.ApiResult;
import com.penghaisoft.momeam.commonbase.entity.BaseEntity;
import com.penghaisoft.momeam.commonbase.enums.ActiveFlag;
import com.penghaisoft.momeam.commonbase.exception.BusinessException;
import com.penghaisoft.momeam.commonbase.utils.SecurityInfoUtil;
import com.penghaisoft.momeam.commonservice.constant.CommonUrlProperty;
import com.penghaisoft.momeam.commonservice.entity.CommonWarningReport;
import com.penghaisoft.momeam.commonservice.enums.MomInterfaceEnum;
import com.penghaisoft.momeam.commonservice.utils.MomHttp;
import com.penghaisoft.momeam.commonservice.utils.PageSupport;
import com.penghaisoft.momeam.commonservice.utils.spring.ServletUtils;
import com.penghaisoft.momeam.eammobile.extensionequipment.mapper.EamExtensionEquipmentMapper;
import com.penghaisoft.momeam.eammobile.maintainfaultimage.entity.EamMaintainFaultImage;
import com.penghaisoft.momeam.eammobile.maintainfaultimage.mapper.EamMaintainFaultImageMapper;
import com.penghaisoft.momeam.eammobile.maintainorder.entity.DTO.SparePartDTO;
import com.penghaisoft.momeam.eammobile.maintainorder.entity.EamMaintainOrder;
import com.penghaisoft.momeam.eammobile.maintainorder.mapper.EamMaintainOrderMapper;
import com.penghaisoft.momeam.eammobile.maintainorder.service.IEamMaintainOrderService;
import com.penghaisoft.momeam.eammobile.maintainorderlog.entity.EamMaintainOrderLog;
import com.penghaisoft.momeam.eammobile.maintainorderlog.entity.constant.HandleType;
import com.penghaisoft.momeam.eammobile.maintainorderlog.mapper.EamMaintainOrderLogMapper;
import com.penghaisoft.momeam.eammobile.maintainorderpart.entity.EamMaintainOrderPart;
import com.penghaisoft.momeam.eammobile.maintainorderpart.mapper.EamMaintainOrderPartMapper;
import com.penghaisoft.momeam.eammobile.maintainsolutionimage.entity.EamMaintainSolutionImage;
import com.penghaisoft.momeam.eammobile.maintainsolutionimage.mapper.EamMaintainSolutionImageMapper;
import com.penghaisoft.momeam.eammobile.sparePart.entity.EamSparePart;
import com.penghaisoft.momeam.eammobile.sparePart.entity.EamWorkOrderPartVo;
import com.penghaisoft.momeam.eammobile.sparePart.mapper.EamSparePartMapper;
import com.penghaisoft.momeam.eammobile.sparepartout.entity.EamSpareStockOutAll;
import com.penghaisoft.momeam.eammobile.sparepartout.service.IEamSpareStockOutService;
import java.lang.invoke.SerializedLambda;
import java.util.Arrays;
import java.util.List;
import javax.annotation.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class EamMaintainOrderServiceImpl implements IEamMaintainOrderService {
  private static final Logger log = LoggerFactory.getLogger(com.penghaisoft.momeam.eammobile.maintainorder.service.impl.EamMaintainOrderServiceImpl.class);
  
  @Autowired
  private EamMaintainOrderMapper eamMaintainOrderMapper;
  
  @Autowired
  private EamMaintainFaultImageMapper eamMaintainFaultImageMapper;
  
  @Autowired
  private EamMaintainSolutionImageMapper eamMaintainSolutionImageMapper;
  
  @Autowired
  private EamMaintainOrderLogMapper eamMaintainOrderLogMapper;
  
  @Autowired
  private EamMaintainOrderPartMapper eamMaintainOrderPartMapper;
  
  @Autowired
  private EamExtensionEquipmentMapper eamExtensionEquipmentMapper;
  
  @Autowired
  private UserInfoService userInfoService;
  
  private final EamSparePartMapper eamSparePartMapper;
  
  private final IEamSpareStockOutService eamSpareStockOutService;
  
  @Resource
  private CommonUrlProperty commonUrlProperty;
  
  public EamMaintainOrderServiceImpl(EamSparePartMapper eamSparePartMapper, IEamSpareStockOutService eamSpareStockOutService) {
    this.eamSparePartMapper = eamSparePartMapper;
    this.eamSpareStockOutService = eamSpareStockOutService;
  }
  
  public EamMaintainOrder detail(Long id) {
    EamMaintainOrder eamMaintainOrder = (EamMaintainOrder)this.eamMaintainOrderMapper.selectById(id);
    QueryWrapper<EamMaintainFaultImage> wrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)wrapper.lambda()
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getOrderCode()), EamMaintainFaultImage::getOrderCode, eamMaintainOrder
        .getOrderCode()))
      .eq(EamMaintainFaultImage::getOrderType, "0"))
      .eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(EamMaintainFaultImage::getFactoryCode, this.userInfoService.getCurrentFactory().getModelingCode());
    EamMaintainFaultImage image = (EamMaintainFaultImage)this.eamMaintainFaultImageMapper.selectOne((Wrapper)wrapper);
    if (image != null)
      eamMaintainOrder.setPicUrl(image.getFaultImagePath()); 
    return eamMaintainOrder;
  }
  
  public EamMaintainOrder detailWithpart(Long id) {
    EamMaintainOrder eamMaintainOrder = this.eamMaintainOrderMapper.selectDetailWithPartById(id);
    QueryWrapper<EamMaintainFaultImage> wrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)wrapper.lambda()
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getOrderCode()), EamMaintainFaultImage::getOrderCode, eamMaintainOrder
        .getOrderCode()))
      .eq(EamMaintainFaultImage::getOrderType, "0"))
      .eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(EamMaintainFaultImage::getFactoryCode, this.userInfoService.getCurrentFactory().getModelingCode());
    EamMaintainFaultImage image = (EamMaintainFaultImage)this.eamMaintainFaultImageMapper.selectOne((Wrapper)wrapper);
    QueryWrapper<EamMaintainSolutionImage> solutionImageQueryWrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)solutionImageQueryWrapper.lambda()
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getOrderCode()), EamMaintainSolutionImage::getOrderCode, eamMaintainOrder
        .getOrderCode()))
      .eq(EamMaintainSolutionImage::getOrderType, "0"))
      .eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(EamMaintainSolutionImage::getFactoryCode, this.userInfoService.getCurrentFactory().getModelingCode());
    EamMaintainSolutionImage solutionImage = (EamMaintainSolutionImage)this.eamMaintainSolutionImageMapper.selectOne((Wrapper)solutionImageQueryWrapper);
    if (image != null)
      eamMaintainOrder.setPicUrl(image.getFaultImagePath()); 
    if (solutionImage != null)
      eamMaintainOrder.setSolutionPicUrl(solutionImage.getSolutionImagePath()); 
    QueryWrapper<EamMaintainOrderLog> logQueryWrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)logQueryWrapper.lambda().eq(EamMaintainOrderLog::getOrderId, eamMaintainOrder.getId()))
      .eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(EamMaintainOrderLog::getOrderType, "0"))
      .eq(EamMaintainOrderLog::getFactoryCode, this.userInfoService.getCurrentFactory().getModelingCode()))
      .orderByAsc(BaseEntity::getCreateTime);
    List<EamMaintainOrderLog> logs = this.eamMaintainOrderLogMapper.selectList((Wrapper)logQueryWrapper);
    eamMaintainOrder.setLogList(logs);
    return eamMaintainOrder;
  }
  
  public IPage<EamMaintainOrder> pageByCondition(EamMaintainOrder eamMaintainOrder) {
    eamMaintainOrder.setOrderPersonCode(null);
    LambdaQueryWrapper<EamMaintainOrder> queryWrapper = generateQueryMapper(eamMaintainOrder);
    queryWrapper.in(EamMaintainOrder::getExecutionStatus, Arrays.asList(new String[] { "1", "2", "3" }));
    IPage<EamMaintainOrder> page = PageSupport.getInstance().buildPage();
    IPage<EamMaintainOrder> rpage = this.eamMaintainOrderMapper.selectPage(page, (Wrapper)queryWrapper);
    for (EamMaintainOrder s : rpage.getRecords()) {
      EamMaintainOrder detailWithPart = this.eamMaintainOrderMapper.selectDetailWithPartById(s.getId());
      if (ObjectUtil.isNotEmpty(detailWithPart.getSparePartList()))
        s.setSparePartList(detailWithPart.getSparePartList()); 
    } 
    return rpage;
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public Long add(EamMaintainOrder eamMaintainOrder) {
    String factoryCode = this.userInfoService.getCurrentFactory().getModelingCode();
    eamMaintainOrder.setExecutionStatus("1");
    eamMaintainOrder.setFactoryCode(factoryCode);
    this.eamMaintainOrderMapper.insert(eamMaintainOrder);
    EamMaintainFaultImage image = new EamMaintainFaultImage();
    image.setOrderCode(eamMaintainOrder.getOrderCode());
    image.setFaultImagePath(eamMaintainOrder.getPicUrl());
    image.setOrderType("0");
    image.setActiveFlag(ActiveFlag.ACTIVE.toString());
    image.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    QueryWrapper<EamMaintainFaultImage> wrapper = getEamMaintainFaultImageQueryWrapper(image);
    this.eamMaintainFaultImageMapper.delete((Wrapper)wrapper);
    this.eamMaintainFaultImageMapper.insert(image);
    EamMaintainOrderLog log = new EamMaintainOrderLog();
    log.setOrderId(eamMaintainOrder.getId());
    log.setHandle(HandleType.ADD.type());
    log.setHandleContent(HandleType.ADD.type());
    log.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    log.setOrderType("0");
    this.eamMaintainOrderLogMapper.insert(log);
    int i = 0;
    if (StringUtils.isNotEmpty(eamMaintainOrder.getDeptCode()))
      if (eamMaintainOrder.getDeptCode().startsWith("JG1001") || eamMaintainOrder
        .getDeptCode().startsWith("JG1002")) {
        i = 1;
      } else if (eamMaintainOrder.getDeptCode().startsWith("JG1003") || eamMaintainOrder
        .getDeptCode().startsWith("JG1004") || eamMaintainOrder
        .getDeptCode().startsWith("JG1005")) {
        i = 2;
      }  
    if (i == 0 || i == 2) {
      CommonWarningReport commonWarningReport = new CommonWarningReport();
      commonWarningReport.setWarningName("新增维修工单：" + eamMaintainOrder.getEquipmentName() + "设备，故障现象:" + eamMaintainOrder
          .getFaultContent() + "，申请人：" + eamMaintainOrder.getCreateByName() + "，请及时处理！");
      commonWarningReport.setWarnSource("设备维修工单");
      commonWarningReport.setIsWarnMessage("0");
      commonWarningReport.setFactoryCode(factoryCode);
      commonWarningReport.setWarnSourceCode(eamMaintainOrder.getOrderCode());
      commonWarningReport.setWarningType("5");
      commonWarningReport.setWarnTypeCode("WXHJ0001");
      sendWarnMessage(ServletUtils.getToken(), commonWarningReport);
    } 
    if (i == 0 || i == 1) {
      CommonWarningReport commonWarningReport = new CommonWarningReport();
      commonWarningReport.setWarningName("新增维修工单：" + eamMaintainOrder.getEquipmentName() + "设备，故障现象:" + eamMaintainOrder
          .getFaultContent() + "，申请人：" + eamMaintainOrder.getCreateByName() + "，请及时处理！");
      commonWarningReport.setWarnSource("设备维修工单");
      commonWarningReport.setIsWarnMessage("0");
      commonWarningReport.setFactoryCode(factoryCode);
      commonWarningReport.setWarnSourceCode(eamMaintainOrder.getOrderCode());
      commonWarningReport.setWarningType("5");
      commonWarningReport.setWarnTypeCode("WXHJ0001-1");
      sendWarnMessage(ServletUtils.getToken(), commonWarningReport);
    } 
    return eamMaintainOrder.getId();
  }
  
  private void sendWarnMessage(String token, CommonWarningReport commonWarningReport) {
    String url = this.commonUrlProperty.getCommonService() + this.commonUrlProperty.getCommonService();
    HttpResponse httpResponse = MomHttp.post(url).targetSys(MomInterfaceEnum.COMMON_ADD_WARNING_REPORT.getTargetSys()).bearerAuth(token).body(JSON.toJSONString(commonWarningReport)).execute();
    ApiResult<JSONArray> orderResultVo = (ApiResult<JSONArray>)JSON.parseObject(httpResponse.body(), ApiResult.class);
    if (!orderResultVo.getSuccess()) {
      log.error("添加消息记录：{}", orderResultVo.getMessage());
      throw new BusinessException("调用 添加消息记录 接口失败：{}" + orderResultVo.getMessage());
    } 
    log.info("执行工步：添加消息记录失败！ ");
  }
  
  public Boolean update(EamMaintainOrder eamMaintainOrder) {
    int count = this.eamMaintainOrderMapper.updateById(eamMaintainOrder);
    EamMaintainFaultImage image = new EamMaintainFaultImage();
    image.setOrderCode(eamMaintainOrder.getOrderCode());
    image.setFaultImagePath(eamMaintainOrder.getPicUrl());
    image.setOrderType("0");
    image.setActiveFlag(ActiveFlag.ACTIVE.toString());
    image.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    QueryWrapper<EamMaintainFaultImage> wrapper = getEamMaintainFaultImageQueryWrapper(image);
    this.eamMaintainFaultImageMapper.delete((Wrapper)wrapper);
    this.eamMaintainFaultImageMapper.insert(image);
    return Boolean.valueOf((count > 0));
  }
  
  @Transactional
  public Boolean examine(EamMaintainOrder eamMaintainOrder) {
    eamMaintainOrder.setApproverPersonCode(SecurityInfoUtil.getUser().getId());
    eamMaintainOrder.setApproverPersonName(SecurityInfoUtil.getUser().getUsername());
    int count = this.eamMaintainOrderMapper.updateById(eamMaintainOrder);
    EamMaintainOrderLog log = new EamMaintainOrderLog();
    log.setOrderId(eamMaintainOrder.getId());
    log.setHandle(HandleType.EXAMINE.type());
    if (eamMaintainOrder.getExecutionStatus().equals("1")) {
      log.setHandleContent("审核不通过");
    } else if (eamMaintainOrder.getExecutionStatus().equals("4")) {
      log.setHandleContent("审核通过");
    } 
    log.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    log.setOrderType("0");
    this.eamMaintainOrderLogMapper.insert(log);
    return Boolean.valueOf((count > 0));
  }
  
  @Transactional
  public Boolean assign(EamMaintainOrder eamMaintainOrder) {
    eamMaintainOrder.setDispatchingPersonCode(SecurityInfoUtil.getUser().getId());
    eamMaintainOrder.setDispatchingPersonName(SecurityInfoUtil.getUser().getUsername());
    eamMaintainOrder.setExecutionStatus("1");
    int count = this.eamMaintainOrderMapper.updateById(eamMaintainOrder);
    EamMaintainOrderLog log = new EamMaintainOrderLog();
    log.setOrderId(eamMaintainOrder.getId());
    log.setHandle(HandleType.ASSIGN.type());
    log.setHandleContent("分派给" + eamMaintainOrder.getOrderPersonName());
    log.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    log.setOrderType("0");
    this.eamMaintainOrderLogMapper.insert(log);
    return Boolean.valueOf((count > 0));
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public Boolean implement(EamMaintainOrder eamMaintainOrder) {
    List<EamMaintainOrderPart> sparePartList = eamMaintainOrder.getSparePartList();
    QueryWrapper<EamMaintainOrderPart> partQueryWrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)partQueryWrapper.lambda().eq(EamMaintainOrderPart::getOrderId, eamMaintainOrder.getId()))
      .eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(EamMaintainOrderPart::getFactoryCode, this.userInfoService.getCurrentFactory().getModelingCode());
    this.eamMaintainOrderPartMapper.delete((Wrapper)partQueryWrapper);
    List<EamSpareStockOutAll> eamSpareStockOutAll = Lists.newArrayList();
    if (CollectionUtil.isNotEmpty(sparePartList)) {
      for (EamMaintainOrderPart part : sparePartList) {
        EamSpareStockOutAll spareStockOutAll = new EamSpareStockOutAll();
        part.setOrderId(eamMaintainOrder.getId());
        part.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
        part.setActiveFlag(ActiveFlag.ACTIVE.toString());
        spareStockOutAll.setPartCategoryCode("1");
        spareStockOutAll.setPartCategoryName("维修领料");
        spareStockOutAll.setWarehouseCode(part.getWarehouseCode());
        spareStockOutAll.setWarehouseName(part.getWarehouseName());
        spareStockOutAll.setRelateOrderType("0");
        spareStockOutAll.setRelateOrderNo(eamMaintainOrder.getOrderCode());
        spareStockOutAll.setSparePartCount(part.getSparePartNumber());
        spareStockOutAll.setSparePartCode(part.getSparePartCode());
        eamSpareStockOutAll.add(spareStockOutAll);
      } 
      this.eamMaintainOrderPartMapper.batchAdd(sparePartList);
    } 
    if (CollectionUtils.isNotEmpty(eamSpareStockOutAll))
      this.eamSpareStockOutService.saveAndCheckStockout(eamSpareStockOutAll); 
    EamMaintainSolutionImage image = new EamMaintainSolutionImage();
    image.setOrderCode(eamMaintainOrder.getOrderCode());
    image.setSolutionImagePath(eamMaintainOrder.getSolutionPicUrl());
    image.setOrderType("0");
    image.setActiveFlag(ActiveFlag.ACTIVE.toString());
    image.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    QueryWrapper<EamMaintainSolutionImage> wrapper = getEamMaintainSolutionImageQueryWrapper(image);
    this.eamMaintainSolutionImageMapper.delete((Wrapper)wrapper);
    this.eamMaintainSolutionImageMapper.insert(image);
    eamMaintainOrder.setExecutionStatus("2");
    int count = this.eamMaintainOrderMapper.updateById(eamMaintainOrder);
    EamMaintainOrderLog log = new EamMaintainOrderLog();
    log.setOrderId(eamMaintainOrder.getId());
    log.setHandle(HandleType.IMPLEMENT.type());
    log.setHandleContent(HandleType.IMPLEMENT.type());
    log.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    log.setOrderType("0");
    this.eamMaintainOrderLogMapper.insert(log);
    return Boolean.valueOf((count > 0));
  }
  
  @Transactional
  public Boolean revoke(EamMaintainOrder eamMaintainOrder) {
    EamMaintainOrderLog log = new EamMaintainOrderLog();
    log.setOrderId(eamMaintainOrder.getId());
    log.setHandle(HandleType.REVOKE.type());
    log.setHandleContent(HandleType.REVOKE.type());
    log.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    log.setOrderType("0");
    this.eamMaintainOrderLogMapper.insert(log);
    int count = this.eamMaintainOrderMapper.updateById(eamMaintainOrder);
    return Boolean.valueOf((count > 0));
  }
  
  public Boolean delete(String ids) {
    this.eamMaintainOrderMapper.deleteBatchIds(Arrays.asList(ids.split(",")));
    return Boolean.valueOf(true);
  }
  
  public Boolean fakeDelete(String ids) {
    int count = this.eamMaintainOrderMapper.update(null, 
        (Wrapper)((LambdaUpdateWrapper)Wrappers.lambdaUpdate()
        .set(BaseEntity::getActiveFlag, ActiveFlag.INACTIVE.toString()))
        .in(EamMaintainOrder::getId, Arrays.asList(ids.split(","))));
    return Boolean.valueOf((count > 0));
  }
  
  public List<EamMaintainOrder> selectList(EamMaintainOrder eamMaintainOrder) {
    LambdaQueryWrapper<EamMaintainOrder> queryWrapper = generateQueryMapper(eamMaintainOrder);
    return this.eamMaintainOrderMapper.selectList((Wrapper)queryWrapper);
  }
  
  public IPage<EamSparePart> selectEquipmentSparePart(SparePartDTO partDTO) {
    IPage<EamSparePart> page = PageSupport.getInstance().buildPage();
    partDTO.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    partDTO.setOrderId(partDTO.getOrderId());
    Page<EamSparePart> eamSparePartPage = this.eamMaintainOrderMapper.selectEquipmentSparePartByOrderId((Page)page, partDTO);
    return (IPage<EamSparePart>)eamSparePartPage;
  }
  
  public IPage<EamWorkOrderPartVo> getEquipmentSparePart(SparePartDTO partDTO) {
    IPage<EamSparePart> page = PageSupport.getInstance().buildPage();
    partDTO.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    partDTO.setEquipmentCode(partDTO.getEquipmentCode());
    Page<EamWorkOrderPartVo> eamSparePartPage = this.eamMaintainOrderMapper.getEquipmentSparePart((Page)page, partDTO);
    return (IPage<EamWorkOrderPartVo>)eamSparePartPage;
  }
  
  public List<EamWorkOrderPartVo> getEquipmentSparePartList(SparePartDTO partDTO) {
    IPage<EamSparePart> page = PageSupport.getInstance().buildPage();
    partDTO.setFactoryCode(this.userInfoService.getCurrentFactory().getModelingCode());
    partDTO.setEquipmentCode(partDTO.getEquipmentCode());
    List<EamWorkOrderPartVo> eamSparePartPage = this.eamMaintainOrderMapper.getEquipmentSparePartList(partDTO);
    return eamSparePartPage;
  }
  
  private LambdaQueryWrapper<EamMaintainOrder> generateQueryMapper(EamMaintainOrder eamMaintainOrder) {
    QueryWrapper<EamMaintainOrder> queryWrapper = PageSupport.getInstance().buildSortWrapper();
    return (LambdaQueryWrapper<EamMaintainOrder>)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)queryWrapper.lambda().eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(EamMaintainOrder::getFactoryCode, this.userInfoService.getCurrentFactory().getModelingCode()))
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getPriorityCode()), EamMaintainOrder::getPriorityCode, eamMaintainOrder
        .getPriorityCode()))
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getExecutionStatus()), EamMaintainOrder::getExecutionStatus, eamMaintainOrder
        .getExecutionStatus()))
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getDispatchingPersonCode()), EamMaintainOrder::getDispatchingPersonCode, eamMaintainOrder
        .getDispatchingPersonCode()))
      .like(StrUtil.isNotEmpty(eamMaintainOrder.getOrderSource()), EamMaintainOrder::getOrderSource, eamMaintainOrder
        .getOrderSource()))
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getOrderPersonCode()), EamMaintainOrder::getOrderPersonCode, eamMaintainOrder
        .getOrderPersonCode()))
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getOrderCode()), EamMaintainOrder::getOrderCode, eamMaintainOrder
        .getOrderCode()))
      .eq(StrUtil.isNotEmpty(eamMaintainOrder.getEquipmentCode()), EamMaintainOrder::getEquipmentCode, eamMaintainOrder
        .getEquipmentCode()))
      .like(StrUtil.isNotEmpty(eamMaintainOrder.getEquipmentName()), EamMaintainOrder::getEquipmentName, eamMaintainOrder
        .getEquipmentName()))
      .like(StrUtil.isNotEmpty(eamMaintainOrder.getOrderPersonName()), EamMaintainOrder::getOrderPersonName, eamMaintainOrder
        .getOrderPersonName()))
      .like(StrUtil.isNotEmpty(eamMaintainOrder.getExecutionStatus()), EamMaintainOrder::getExecutionStatus, eamMaintainOrder
        .getExecutionStatus()))
      .between((null != eamMaintainOrder.getCreateTimeMin() && null != eamMaintainOrder.getCreateTimeMax()), BaseEntity::getCreateTime, eamMaintainOrder
        .getCreateTimeMin(), eamMaintainOrder
        .getCreateTimeMax()))
      .between((null != eamMaintainOrder.getUpdateTimeMin() && null != eamMaintainOrder.getUpdateTimeMax()), BaseEntity::getUpdateTime, eamMaintainOrder
        .getUpdateTimeMin(), eamMaintainOrder
        .getUpdateTimeMax()))
      .orderByDesc(BaseEntity::getCreateTime);
  }
  
  private QueryWrapper<EamMaintainFaultImage> getEamMaintainFaultImageQueryWrapper(EamMaintainFaultImage image) {
    QueryWrapper<EamMaintainFaultImage> wrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)wrapper.lambda()
      .eq(StrUtil.isNotEmpty(image.getOrderCode()), EamMaintainFaultImage::getOrderCode, image.getOrderCode()))
      .eq(StrUtil.isNotEmpty(image.getOrderType()), EamMaintainFaultImage::getOrderType, image.getOrderType()))
      .eq(StrUtil.isNotEmpty(image.getActiveFlag()), BaseEntity::getActiveFlag, image.getActiveFlag()))
      .eq(StrUtil.isNotEmpty(image.getFactoryCode()), EamMaintainFaultImage::getFactoryCode, image
        .getFactoryCode());
    return wrapper;
  }
  
  private QueryWrapper<EamMaintainSolutionImage> getEamMaintainSolutionImageQueryWrapper(EamMaintainSolutionImage image) {
    QueryWrapper<EamMaintainSolutionImage> wrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)wrapper.lambda()
      .eq(StrUtil.isNotEmpty(image.getOrderCode()), EamMaintainSolutionImage::getOrderCode, image.getOrderCode()))
      .eq(StrUtil.isNotEmpty(image.getOrderType()), EamMaintainSolutionImage::getOrderType, image.getOrderType()))
      .eq(StrUtil.isNotEmpty(image.getActiveFlag()), BaseEntity::getActiveFlag, image
        .getActiveFlag()))
      .eq(StrUtil.isNotEmpty(image.getFactoryCode()), EamMaintainSolutionImage::getFactoryCode, image
        .getFactoryCode());
    return wrapper;
  }
  
  private QueryWrapper<EamMaintainOrderPart> getEamMaintainOrderPartQueryWrapper(EamMaintainOrderPart part) {
    QueryWrapper<EamMaintainOrderPart> wrapper = new QueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)wrapper.lambda()
      .eq(ObjectUtil.isNotNull(part.getOrderId()), EamMaintainOrderPart::getOrderId, part.getOrderId()))
      .eq(StrUtil.isNotEmpty(part.getActiveFlag()), BaseEntity::getActiveFlag, part.getActiveFlag()))
      .eq(StrUtil.isNotEmpty(part.getFactoryCode()), EamMaintainOrderPart::getFactoryCode, part.getFactoryCode());
    return wrapper;
  }
  
  public List<EamSparePart> selectPartList(EamSparePart eamSparePart) {
    LambdaQueryWrapper<EamSparePart> queryWrapper = generateQueryMapperPart(eamSparePart);
    return this.eamSparePartMapper.selectList((Wrapper)queryWrapper);
  }
  
  private LambdaQueryWrapper<EamSparePart> generateQueryMapperPart(EamSparePart eamSparePart) {
    QueryWrapper<EamSparePart> queryWrapper = PageSupport.getInstance().buildSortWrapper();
    return (LambdaQueryWrapper<EamSparePart>)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)queryWrapper.lambda().eq(BaseEntity::getActiveFlag, ActiveFlag.ACTIVE.toString()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getSparePartCode()), EamSparePart::getSparePartCode, eamSparePart
        .getSparePartCode()))
      .like(StrUtil.isNotEmpty(eamSparePart.getSparePartName()), EamSparePart::getSparePartName, eamSparePart
        .getSparePartName()))
      .like(StrUtil.isNotEmpty(eamSparePart.getRfidCode()), EamSparePart::getRfidCode, eamSparePart.getRfidCode()))
      .like(StrUtil.isNotEmpty(eamSparePart.getPartCategoryCode()), EamSparePart::getPartCategoryCode, eamSparePart
        .getPartCategoryCode()))
      .like(StrUtil.isNotEmpty(eamSparePart.getPartCategoryName()), EamSparePart::getPartCategoryName, eamSparePart
        .getPartCategoryName()))
      .like(StrUtil.isNotEmpty(eamSparePart.getBrandName()), EamSparePart::getBrandName, eamSparePart
        .getBrandName()))
      .like(StrUtil.isNotEmpty(eamSparePart.getModelName()), EamSparePart::getModelName, eamSparePart
        .getModelName()))
      .like(StrUtil.isNotEmpty(eamSparePart.getSpecificationTypeName()), EamSparePart::getSpecificationTypeName, eamSparePart
        .getSpecificationTypeName()))
      .like(StrUtil.isNotEmpty(eamSparePart.getSupplierCode()), EamSparePart::getSupplierCode, eamSparePart
        .getSupplierCode()))
      .like(StrUtil.isNotEmpty(eamSparePart.getSupplierName()), EamSparePart::getSupplierName, eamSparePart
        .getSupplierName()))
      .eq((null != eamSparePart.getProductionDate()), EamSparePart::getProductionDate, eamSparePart
        .getProductionDate()))
      .eq((null != eamSparePart.getPurchaseDate()), EamSparePart::getPurchaseDate, eamSparePart.getPurchaseDate()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getIsPivotal()), EamSparePart::getIsPivotal, eamSparePart
        .getIsPivotal()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getIsShare()), EamSparePart::getIsShare, eamSparePart.getIsShare()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getIsForceReplace()), EamSparePart::getIsForceReplace, eamSparePart
        .getIsForceReplace()))
      .eq((null != eamSparePart.getReplaceCycle()), EamSparePart::getReplaceCycle, eamSparePart.getReplaceCycle()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getReplaceUnit()), EamSparePart::getReplaceUnit, eamSparePart
        .getReplaceUnit()))
      .eq((null != eamSparePart.getMinStock()), EamSparePart::getMinStock, eamSparePart.getMinStock()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getSerialUnit()), EamSparePart::getSerialUnit, eamSparePart
        .getSerialUnit()))
      .eq((null != eamSparePart.getPurchaseCycle()), EamSparePart::getPurchaseCycle, eamSparePart
        .getPurchaseCycle()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getPurchaseUnit()), EamSparePart::getPurchaseUnit, eamSparePart
        .getPurchaseUnit()))
      .eq(StrUtil.isNotEmpty(eamSparePart.getFactoryCode()), EamSparePart::getFactoryCode, eamSparePart
        .getFactoryCode()))
      .orderByDesc(BaseEntity::getCreateTime);
  }
}
